"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateMethodName = exports.join = exports.camleCase = exports.bind = exports.invokeSafe = void 0;
/**
 * Accept a potential function and try to invoke it safely.
 * @param {Function} fn - a function that needs to be invoked in a safe way
 */
const invokeSafe = (fn) => {
    try {
        fn();
    }
    catch {
        /**
         *
         */
    }
};
exports.invokeSafe = invokeSafe;
// eslint-disable-next-line @typescript-eslint/no-explicit-any, @typescript-eslint/ban-types
const bind = (fn, reciver, args = []) => {
    if (typeof fn === 'function') {
        return fn.bind(reciver, ...args);
    }
    else {
        return () => { throw new Error('expected a function, recived ' + typeof fn); };
    }
};
exports.bind = bind;
const camleCase = (string) => {
    const firstLetter = string[0].toUpperCase();
    const restOfTheWord = string.slice(1);
    return firstLetter + restOfTheWord;
};
exports.camleCase = camleCase;
/**
 *
 * @param args - a set of arguments that will be passed as array to be joined.
 * @returns {string}  joined string
 */
const join = (...args) => args.join('');
exports.join = join;
const generateMethodName = (method_name, options) => {
    if (options.disableCamelCase === false) {
        method_name = (0, exports.camleCase)(method_name);
    }
    return ({
        invokeAfterName: (0, exports.join)(options.invokeAfterName, method_name),
        invokeBeforeName: (0, exports.join)(options.invokeBeforeName, method_name),
    });
};
exports.generateMethodName = generateMethodName;
//# sourceMappingURL=helpers.js.map