import { OptionsI } from './constants';
/**
 * invokeMeWrapper function will wrap your target (class/object) with a special proxy/wrapper
 * and provid it back to you as a class/object. the method inside your object or class
 * can invoke dynamically (without you calling them).
 * @param {Object | Function} target - A class or object that its methods should be proxied.
 * @param {typex} options - object contains options to customize the functionality wrapper.
 * @returns {Object} if the target is empty, it returns an empty object. otherwise a proxied target returned.
 *
 */
declare function invokeMeWrapper(target: {
    new (...args: unknown[]): object;
} | object, options?: OptionsI): object;
export { invokeMeWrapper };
